/*
 * COMMENT
 */

import java.awt.*;

public class Villain {
    public static final Point CENTRE_POINT = A3Constants.CENTRE_POINT;
    public static final Color[] COLOURS = A3Constants.COLOURS;
    
    public static final int VILLAIN_SIZE = A3Constants.VILLAIN_SIZE; 
    public static final Rectangle INITIAL_VILLAIN_AREA = A3Constants.INITIAL_VILLAIN_AREA;
    
    public static final Rectangle GAME_AREA = A3Constants.GAME_AREA; 
    public static final Rectangle ABOVE_GAME_AREA = A3Constants.ABOVE_GAME_AREA;
    public static final Rectangle BELOW_GAME_AREA = A3Constants.BELOW_GAME_AREA;
    public static final Rectangle LEFT_OF_GAME_AREA = A3Constants.LEFT_OF_GAME_AREA;
    public static final Rectangle RIGHT_OF_GAME_AREA = A3Constants.RIGHT_OF_GAME_AREA;
    
    private int xSpeed;
    private int ySpeed;
    private Rectangle area;
    private Color colour; //optional
    private boolean isVisible;
    
    
    public Villain() {
		this.xSpeed = (int) (Math.random()*21 - 10);
		this.ySpeed = (int) (Math.random()*21 - 10);
		this.area = new Rectangle(INITIAL_VILLAIN_AREA);
		this.colour = new Color(255,0,0);
		this.isVisible = false;
	}
	
	public Rectangle getArea() {
		return area;
	}
	public void setVisible(boolean isVisible) {
		System.out.println("in the Villanin.isVisible: " + isVisible);
		this.isVisible = isVisible;
	}
	public boolean getVisible() {
		return isVisible;
	}
    public void move(){
    	if (this.isVisible){area.setRect(area.getX() + xSpeed, area.getY() + ySpeed, VILLAIN_SIZE, VILLAIN_SIZE);}
    }
    public void draw(Graphics g){
    	if (area.intersects(ABOVE_GAME_AREA) || 
				area.intersects(BELOW_GAME_AREA) || 
				area.intersects(LEFT_OF_GAME_AREA) || 
				area.intersects(RIGHT_OF_GAME_AREA)){
/*			for(int i = 128, t=15; i > 0; i-=(128/10), t--){
				size = (int)(VILLAIN_SIZE * ((double)t/15));
				g.setColor(new Color(i,0,0));
				g.fillOval(x - size/2 , y - size/2, size, size);
				//System.out.println("in my Villain.draw(), the t = " + t);
			}*/
			this.isVisible = false;
		}
    	if (this.isVisible){
    		g.fillOval((int)area.getX() , (int)area.getY(), VILLAIN_SIZE, VILLAIN_SIZE);
    		System.out.println("position is " + area.toString());
    	}
    }
}


